Move lcm certificate to lcm folder in OSM helm chart
[osm/devops.git] / installers / install_osm.sh
1 #!/bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15 REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
16 RELEASE=ReleaseTWELVE
17 REPOSITORY=stable
18 DOCKER_TAG=12
19 DEVOPS_PATH=/usr/share/osm-devops
20
21 function usage(){
22 echo -e "usage: $0 [OPTIONS]"
23 echo -e "Install OSM from binaries or source code (by default, from binaries)"
24 echo -e " OPTIONS"
25 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
27 echo -e " -r <repo>: use specified repository name for osm packages"
28 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
29 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
31 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
32 echo -e " -b master (main dev branch)"
33 echo -e " -b v2.0 (v2.0 branch)"
34 echo -e " -b tags/v1.1.0 (a specific tag)"
35 echo -e " ..."
36 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
37 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
38 echo -e " -H <VCA host> use specific juju host controller IP"
39 echo -e " -S <VCA secret> use VCA/juju secret key"
40 echo -e " -P <VCA pubkey> use VCA/juju public key file"
41 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
42 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
43 echo -e " --pla: install the PLA module for placement support"
44 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
45 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor)"
46 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
47 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, PLA, NONE)"
48 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
49 echo -e " -O <openrc file/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
50 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
51 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
52 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
53 echo -e " -D <devops path> use local devops installation path"
54 echo -e " -w <work dir> Location to store runtime installation"
55 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
56 echo -e " -l: LXD cloud yaml file"
57 echo -e " -L: LXD credentials yaml file"
58 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
59 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
60 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
61 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
62 echo -e " --debug: debug mode"
63 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
64 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
65 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
66 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
67 echo -e " --nojuju: do not juju, assumes already installed"
68 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
69 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
70 echo -e " --nohostclient: do not install the osmclient"
71 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
72 echo -e " --source: install OSM from source code using the latest stable tag"
73 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
74 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
75 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
76 echo -e " --volume: create a VM volume when installing to OpenStack"
77 echo -e " --showopts: print chosen options and exit (only for debugging)"
78 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
79 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
80 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
81 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
82 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
83 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
84 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
85 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
86 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
87 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
88 echo -e " [--tag]: Docker image tag. (--charmed option)"
89 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
90
91 }
92
93 add_repo() {
94 REPO_CHECK="^$1"
95 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
96 if [ $? -ne 0 ]
97 then
98 need_packages_lw="software-properties-common apt-transport-https"
99 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
100 dpkg -l $need_packages_lw &>/dev/null \
101 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
102 || sudo apt-get -qy update \
103 || ! echo "failed to run apt-get update" \
104 || exit 1
105 dpkg -l $need_packages_lw &>/dev/null \
106 || ! echo -e "Installing $need_packages_lw requires root privileges." \
107 || sudo apt-get install -y $need_packages_lw \
108 || ! echo "failed to install $need_packages_lw" \
109 || exit 1
110 wget -q -O OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
111 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
112 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
113 || exit 1
114 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
115 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
116 return 0
117 fi
118
119 return 1
120 }
121
122 clean_old_repo() {
123 dpkg -s 'osm-devops' &> /dev/null
124 if [ $? -eq 0 ]; then
125 # Clean the previous repos that might exist
126 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
127 fi
128 }
129
130 function configure_apt_proxy() {
131 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
132 OSM_APT_PROXY=$1
133 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
134 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
135 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
136 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
137 Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
138 EOF"
139 else
140 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
141 fi
142 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
143 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
144 }
145
146 while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
147 case "${o}" in
148 D)
149 DEVOPS_PATH="${OPTARG}"
150 ;;
151 r)
152 REPOSITORY="${OPTARG}"
153 ;;
154 R)
155 RELEASE="${OPTARG}"
156 ;;
157 u)
158 REPOSITORY_BASE="${OPTARG}"
159 ;;
160 t)
161 DOCKER_TAG="${OPTARG}"
162 ;;
163 -)
164 [ "${OPTARG}" == "help" ] && usage && exit 0
165 ;;
166 :)
167 echo "Option -$OPTARG requires an argument" >&2
168 usage && exit 1
169 ;;
170 \?)
171 echo -e "Invalid option: '-$OPTARG'\n" >&2
172 usage && exit 1
173 ;;
174 h)
175 usage && exit 0
176 ;;
177 *)
178 ;;
179 esac
180 done
181
182 clean_old_repo
183 add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
184 sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
185 sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
186 $DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"